Code

mktree: fix a memory leak in write_tree()
[git.git] / git-sh-setup.sh
index 98959600ebf5ccc3693d1b3048ebcd59696b64d0..185c5c6c95df389e0d7f39f47feeabbe67124e80 100755 (executable)
@@ -28,12 +28,28 @@ set_reflog_action() {
        fi
 }
 
+git_editor() {
+       : "${GIT_EDITOR:=$(git config core.editor)}"
+       : "${GIT_EDITOR:=${VISUAL:-${EDITOR}}}"
+       case "$GIT_EDITOR,$TERM" in
+       ,dumb)
+               echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
+               echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb."
+               echo >&2 "Please set one of these variables to an appropriate"
+               echo >&2 "editor or run $0 with options that will not cause an"
+               echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)."
+               exit 1
+               ;;
+       esac
+       eval "${GIT_EDITOR:=vi}" '"$@"'
+}
+
 is_bare_repository () {
-       git-rev-parse --is-bare-repository
+       git rev-parse --is-bare-repository
 }
 
 cd_to_toplevel () {
-       cdup=$(git-rev-parse --show-cdup)
+       cdup=$(git rev-parse --show-cdup)
        if test ! -z "$cdup"
        then
                cd "$cdup" || {
@@ -44,8 +60,7 @@ cd_to_toplevel () {
 }
 
 require_work_tree () {
-       test $(git-rev-parse --is-inside-work-tree) = true &&
-       test $(git-rev-parse --is-inside-git-dir) = false ||
+       test $(git rev-parse --is-inside-work-tree) = true ||
        die "fatal: $0 cannot be used without a working tree."
 }
 
@@ -95,12 +110,22 @@ esac
 if [ -z "$SUBDIRECTORY_OK" ]
 then
        : ${GIT_DIR=.git}
-       GIT_DIR=$(GIT_DIR="$GIT_DIR" git-rev-parse --git-dir) || {
+       GIT_DIR=$(GIT_DIR="$GIT_DIR" git rev-parse --git-dir) || {
                exit=$?
                echo >&2 "You need to run this command from the toplevel of the working tree."
                exit $exit
        }
 else
-       GIT_DIR=$(git-rev-parse --git-dir) || exit
+       GIT_DIR=$(git rev-parse --git-dir) || {
+           exit=$?
+           echo >&2 "Failed to find a valid git directory."
+           exit $exit
+       }
 fi
+
+test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
+    echo >&2 "Unable to determine absolute path of git directory"
+    exit 1
+}
+
 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}